Subject: Re: [PATCH] net: raise RCU qs after each threaded NAPI poll

From: Jakub Kicinski <[email-masked]>
Date: Wed, 28 Feb 2024 07:35:44 -0800

On Wed, 28 Feb 2024 07:15:42 -0800 Paul E. McKenney wrote:
> > > Another complication is that although CONFIG_PREEMPT_RT kernels are
> > > built with CONFIG_PREEMPT_RCU, the reverse is not always the case.
> > > And if we are not repolling, don't we have a high probability of doing
> > > a voluntary context when we reach napi_thread_wait() at the beginning
> > > of that loop?  
> > 
> > Very much so, which is why adding the cost of rcu_softirq_qs()
> > for every NAPI run feels like an overkill.  
> 
> Would it be better to do the rcu_softirq_qs() only once every 1000 times
> or some such?  Or once every HZ jiffies?
> 
> Or is there a better way?

Right, we can do that. Yan Zhai, have you measured the performance
impact / time spent in the call?